#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "ftd2xx.h"
#include <QString>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    FT_STATUS	ftStatus;
    //FT_HANDLE	ftHandle0;
    DWORD libraryVersion = 0;
    int iport = 0;
    static FT_PROGRAM_DATA Data;
    static FT_DEVICE ftDevice;

    univ1 = new univers();

    system("sudo rmmod ftdi_sio 2> /dev/null"); // Invalide le driver VCP pour repasser en driver D2XX
    system("sudo rmmod usbserial 2> /dev/null");// Le rsultat de l'opration n'apparait pas  l'cran
    //system("sudo -s");
    //system("sudo -c \"chmod -R 777 /dev/bus/usb/001/011\"");

    ftStatus = FT_GetLibraryVersion(&libraryVersion);
    ftStatus = FT_Open(iport, &ftHandle0);
    ftStatus = FT_GetDeviceInfo(ftHandle0,
                                    &ftDevice,
                                    NULL,
                                    NULL,
                                    NULL,
                                    NULL);
    Data.Signature1 = 0x00000000;
    Data.Signature2 = 0xffffffff;
    Data.Manufacturer = (char *)malloc(256); /* E.g "FTDI" */
    Data.ManufacturerId = (char *)malloc(256); /* E.g. "FT" */
    Data.Description = (char *)malloc(256); /* E.g. "USB HS Serial Converter" */
    Data.SerialNumber = (char *)malloc(256); /* E.g. "FT000001" if fixed, or NULL */

    ftStatus = FT_EE_Read(ftHandle0, &Data);

        ui->label_15->setText(Data.Manufacturer);

QString tempo = Data.SerialNumber;
//ui->label_pix->setText(tempo);
QString UltraDmxMicro="6AYNV8T6";
QString ProMk2="ENXEQ5PX";
QString ProMk2b="ENWEOF1P";
QString UltraDmxRdmPro="6AXO5KJ6";
//QPixmap pix;
/*        if (tempo.compare(UltraDmxMicro)==0) pix=("UltraDMX_micro.png");
        else if (tempo.compare(ProMk2)==0) pix=("PRO_Mk2.png");
        else if (tempo.compare(UltraDmxRdmPro)==0) pix=("ultraDMX_RDMPro.png");*/

        if (tempo.compare(UltraDmxMicro)==0)
            {
            ui->label_pix->setPixmap(QPixmap("UltraDMX_micro.png"));
            ui->label_16->setText("UltraDMX micro");
            }
        else if ((tempo.compare(ProMk2)==0)||(tempo.compare(ProMk2b)==0))
            {
            ui->label_pix->setPixmap(QPixmap("PRO_Mk2.png"));
            ui->label_16->setText("DMX USB PRO Mk2");
            }
        else if (tempo.compare(UltraDmxRdmPro)==0)
            {
            ui->label_pix->setPixmap(QPixmap("ultraDMX_RDMPro.png"));
            ui->label_16->setText("UltraDMX RDM Pro");
            }

        //       QPixmap pix("UltraDMX_micro.png");
       // QPixmap pix("PRO_Mk2.png");
       // QPixmap pix("ultraDMX_RDMPro.png");
   //     ui->label_pix->setPixmap(pix);

        int ReadTimeout = 120;
        int WriteTimeout = 100;
        uint8_t latencyTimer;
        #define RX_BUFFER_SIZE 40960
        #define TX_BUFFER_SIZE 40960
        //
        // Purge rx and tx buffers
        //
        #define FT_PURGE_RX     1
        #define FT_PURGE_TX     2
        #define NO_RESPONSE     0
        ftStatus = FT_GetLatencyTimer (ftHandle0,(PUCHAR)&latencyTimer);
        // These are important values that can be altered to suit your needs
        // Timeout in microseconds: Too high or too low value should not be used
        FT_SetTimeouts(ftHandle0,ReadTimeout,WriteTimeout);
        // Buffer size in bytes (multiple of 4096)
        FT_SetUSBParameters(ftHandle0,RX_BUFFER_SIZE,TX_BUFFER_SIZE);
        // Good idea to purge the buffer on initialize
        FT_Purge (ftHandle0,FT_PURGE_RX);

        int res=0;
        #define DMX_DATA_LENGTH 513 // Includes the start code
//        unsigned char myDmx[DMX_DATA_LENGTH];
        #define HARDWARE_VERSION_LABEL			14

//        memset(myDmx,0,DMX_DATA_LENGTH);
}

MainWindow::~MainWindow()
{
    delete ui;
    univ1->reset_canaux();  //Extinction de tous les canaux avant de fermer le fentre
    univ1->transfert_ftdi(6, 513, ftHandle0);
    delete univ1;
}

void MainWindow::on_verticalSlider_1_valueChanged(int value)
{
    ui->label->setNum(value);
    univ1->set_valeur(1,value);
    ui->label_11->setNum(univ1->get_valeur(1));
 /*      univ1->set_valeur(1,255);
       univ1->set_valeur(2,255);
       univ1->set_valeur(3,255);
       univ1->set_valeur(4,255);
       univ1->set_valeur(5,255);
       univ1->set_valeur(6,255);
       univ1->set_valeur(7,255);
       univ1->set_valeur(8,255);
ui->label_11->setNum(univ1->transfert_ftdi(6, 513, ftHandle0));*/
       univ1->transfert_ftdi(6, 513, ftHandle0);
}

void MainWindow::on_verticalSlider_2_valueChanged(int value)
{
    ui->label_2->setNum(value);
    univ1->set_valeur(2,value);
    ui->label_12->setNum(univ1->get_valeur(2));
//ui->label_12->setNum(univ1->transfert_ftdi(6, 513, ftHandle0));
    univ1->transfert_ftdi(6, 513, ftHandle0);
}

void MainWindow::on_verticalSlider_3_valueChanged(int value)
{
    ui->label_3->setNum(value);
    univ1->set_valeur(3,value);
    ui->label_13->setNum(univ1->get_valeur(3));
//ui->label_13->setNum(univ1->transfert_ftdi(6, 513, ftHandle0));
    univ1->transfert_ftdi(6, 513, ftHandle0);
}

void MainWindow::on_verticalSlider_4_valueChanged(int value)
{
    ui->label_4->setNum(value);
    univ1->set_valeur(4,value);
    ui->label_14->setNum(univ1->get_valeur(4));
//ui->label_14->setNum(univ1->transfert_ftdi(6, 513, ftHandle0));
    univ1->transfert_ftdi(6, 513, ftHandle0);
}


